# octavia.controller.worker.v2 package

## Subpackages

- octavia.controller.worker.v2.flows package
  - Submodules
  - octavia.controller.worker.v2.flows.amphora_flows module
    - `AmphoraFlows`
      - `AmphoraFlows.cert_rotate_amphora_flow()`
      - `AmphoraFlows.get_amphora_for_lb_failover_subflow()`
      - `AmphoraFlows.get_amphora_for_lb_subflow()`
      - `AmphoraFlows.get_create_amphora_flow()`
      - `AmphoraFlows.get_delete_amphora_flow()`
      - `AmphoraFlows.get_failover_amphora_flow()`
      - `AmphoraFlows.get_vrrp_subflow()`
      - `AmphoraFlows.update_amphora_config_flow()`
  - octavia.controller.worker.v2.flows.flow_utils module
    - `cert_rotate_amphora_flow()`
    - `get_batch_update_members_flow()`
    - `get_cascade_delete_load_balancer_flow()`
    - `get_create_all_listeners_flow()`
    - `get_create_amphora_flow()`
    - `get_create_health_monitor_flow()`
    - `get_create_l7policy_flow()`
    - `get_create_l7rule_flow()`
    - `get_create_listener_flow()`
    - `get_create_load_balancer_flow()`
    - `get_create_member_flow()`
    - `get_create_pool_flow()`
    - `get_delete_amphora_flow()`
    - `get_delete_health_monitor_flow()`
    - `get_delete_l7policy_flow()`
    - `get_delete_l7rule_flow()`
    - `get_delete_listener_flow()`
    - `get_delete_load_balancer_flow()`
    - `get_delete_member_flow()`
    - `get_delete_pool_flow()`
    - `get_failover_LB_flow()`
    - `get_failover_amphora_flow()`
    - `get_listeners_on_lb()`
    - `get_pools_on_lb()`
    - `get_update_health_monitor_flow()`
    - `get_update_l7policy_flow()`
    - `get_update_l7rule_flow()`
    - `get_update_listener_flow()`
    - `get_update_load_balancer_flow()`
    - `get_update_member_flow()`
    - `get_update_pool_flow()`
    - `update_amphora_config_flow()`
  - octavia.controller.worker.v2.flows.health_monitor_flows module
    - `HealthMonitorFlows`
      - `HealthMonitorFlows.get_create_health_monitor_flow()`
      - `HealthMonitorFlows.get_delete_health_monitor_flow()`
      - `HealthMonitorFlows.get_update_health_monitor_flow()`
  - octavia.controller.worker.v2.flows.l7policy_flows module
    - `L7PolicyFlows`
      - `L7PolicyFlows.get_create_l7policy_flow()`
      - `L7PolicyFlows.get_delete_l7policy_flow()`
      - `L7PolicyFlows.get_update_l7policy_flow()`
  - octavia.controller.worker.v2.flows.l7rule_flows module
    - `L7RuleFlows`
      - `L7RuleFlows.get_create_l7rule_flow()`
      - `L7RuleFlows.get_delete_l7rule_flow()`
      - `L7RuleFlows.get_update_l7rule_flow()`
  - octavia.controller.worker.v2.flows.listener_flows module
    - `ListenerFlows`
      - `ListenerFlows.get_create_all_listeners_flow()`
      - `ListenerFlows.get_create_listener_flow()`
      - `ListenerFlows.get_delete_listener_flow()`
      - `ListenerFlows.get_delete_listener_internal_flow()`
      - `ListenerFlows.get_update_listener_flow()`
  - octavia.controller.worker.v2.flows.load_balancer_flows module
    - `LoadBalancerFlows`
      - `LoadBalancerFlows.get_cascade_delete_load_balancer_flow()`
      - `LoadBalancerFlows.get_create_load_balancer_flow()`
      - `LoadBalancerFlows.get_delete_load_balancer_flow()`
      - `LoadBalancerFlows.get_failover_LB_flow()`
      - `LoadBalancerFlows.get_post_lb_amp_association_flow()`
      - `LoadBalancerFlows.get_update_load_balancer_flow()`
  - octavia.controller.worker.v2.flows.member_flows module
    - `MemberFlows`
      - `MemberFlows.get_batch_update_members_flow()`
      - `MemberFlows.get_create_member_flow()`
      - `MemberFlows.get_delete_member_flow()`
      - `MemberFlows.get_update_member_flow()`
  - octavia.controller.worker.v2.flows.pool_flows module
    - `PoolFlows`
      - `PoolFlows.get_create_pool_flow()`
      - `PoolFlows.get_delete_pool_flow()`
      - `PoolFlows.get_delete_pool_flow_internal()`
      - `PoolFlows.get_update_pool_flow()`
  - Module contents
- octavia.controller.worker.v2.tasks package
  - Submodules
  - octavia.controller.worker.v2.tasks.amphora_driver_tasks module
    - `AmpListenersUpdate`
      - `AmpListenersUpdate.execute()`
    - `AmpRetry`
      - `AmpRetry.on_failure()`
    - `AmphoraCertUpload`
      - `AmphoraCertUpload.execute()`
    - `AmphoraComputeConnectivityWait`
      - `AmphoraComputeConnectivityWait.execute()`
    - `AmphoraConfigUpdate`
      - `AmphoraConfigUpdate.execute()`
    - `AmphoraFinalize`
      - `AmphoraFinalize.execute()`
      - `AmphoraFinalize.revert()`
    - `AmphoraGetDiagnostics`
      - `AmphoraGetDiagnostics.execute()`
    - `AmphoraGetInfo`
      - `AmphoraGetInfo.execute()`
    - `AmphoraIndexListenerUpdate`
      - `AmphoraIndexListenerUpdate.execute()`
    - `AmphoraIndexListenersReload`
      - `AmphoraIndexListenersReload.execute()`
    - `AmphoraIndexUpdateVRRPInterface`
      - `AmphoraIndexUpdateVRRPInterface.execute()`
    - `AmphoraIndexVRRPStart`
      - `AmphoraIndexVRRPStart.execute()`
    - `AmphoraIndexVRRPUpdate`
      - `AmphoraIndexVRRPUpdate.execute()`
    - `AmphoraPostNetworkPlug`
      - `AmphoraPostNetworkPlug.execute()`
      - `AmphoraPostNetworkPlug.revert()`
    - `AmphoraPostVIPPlug`
      - `AmphoraPostVIPPlug.execute()`
      - `AmphoraPostVIPPlug.revert()`
    - `AmphoraUpdateVRRPInterface`
      - `AmphoraUpdateVRRPInterface.execute()`
    - `AmphoraVRRPStart`
      - `AmphoraVRRPStart.execute()`
    - `AmphoraVRRPUpdate`
      - `AmphoraVRRPUpdate.execute()`
    - `AmphoraeGetConnectivityStatus`
      - `AmphoraeGetConnectivityStatus.execute()`
    - `AmphoraePostNetworkPlug`
      - `AmphoraePostNetworkPlug.execute()`
      - `AmphoraePostNetworkPlug.revert()`
    - `AmphoraePostVIPPlug`
      - `AmphoraePostVIPPlug.execute()`
    - `BaseAmphoraTask`
    - `ListenerDelete`
      - `ListenerDelete.execute()`
      - `ListenerDelete.revert()`
    - `ListenersStart`
      - `ListenersStart.execute()`
      - `ListenersStart.revert()`
    - `ListenersUpdate`
      - `ListenersUpdate.execute()`
      - `ListenersUpdate.revert()`
    - `SetAmphoraFirewallRules`
      - `SetAmphoraFirewallRules.execute()`
  - octavia.controller.worker.v2.tasks.cert_task module
    - `BaseCertTask`
    - `GenerateServerPEMTask`
      - `GenerateServerPEMTask.execute()`
  - octavia.controller.worker.v2.tasks.compute_tasks module
    - `AttachPort`
      - `AttachPort.execute()`
      - `AttachPort.revert()`
    - `BaseComputeTask`
    - `CertComputeCreate`
      - `CertComputeCreate.execute()`
    - `ComputeCreate`
      - `ComputeCreate.execute()`
      - `ComputeCreate.revert()`
    - `ComputeDelete`
      - `ComputeDelete.execute()`
    - `ComputeRetry`
      - `ComputeRetry.on_failure()`
    - `ComputeWait`
      - `ComputeWait.execute()`
    - `DeleteAmphoraeOnLoadBalancer`
      - `DeleteAmphoraeOnLoadBalancer.execute()`
    - `NovaServerGroupCreate`
      - `NovaServerGroupCreate.execute()`
      - `NovaServerGroupCreate.revert()`
    - `NovaServerGroupDelete`
      - `NovaServerGroupDelete.execute()`
  - octavia.controller.worker.v2.tasks.database_tasks module
    - `AssociateFailoverAmphoraWithLBID`
      - `AssociateFailoverAmphoraWithLBID.execute()`
      - `AssociateFailoverAmphoraWithLBID.revert()`
    - `BaseDatabaseTask`
    - `CountPoolChildrenForQuota`
      - `CountPoolChildrenForQuota.execute()`
    - `CreateAmphoraInDB`
      - `CreateAmphoraInDB.execute()`
      - `CreateAmphoraInDB.revert()`
    - `CreateVRRPGroupForLB`
      - `CreateVRRPGroupForLB.execute()`
    - `DecrementHealthMonitorQuota`
      - `DecrementHealthMonitorQuota.execute()`
      - `DecrementHealthMonitorQuota.revert()`
    - `DecrementL7policyQuota`
      - `DecrementL7policyQuota.execute()`
      - `DecrementL7policyQuota.revert()`
    - `DecrementL7ruleQuota`
      - `DecrementL7ruleQuota.execute()`
      - `DecrementL7ruleQuota.revert()`
    - `DecrementListenerQuota`
      - `DecrementListenerQuota.execute()`
      - `DecrementListenerQuota.revert()`
    - `DecrementLoadBalancerQuota`
      - `DecrementLoadBalancerQuota.execute()`
      - `DecrementLoadBalancerQuota.revert()`
    - `DecrementMemberQuota`
      - `DecrementMemberQuota.execute()`
      - `DecrementMemberQuota.revert()`
    - `DecrementPoolQuota`
      - `DecrementPoolQuota.execute()`
      - `DecrementPoolQuota.revert()`
    - `DeleteHealthMonitorInDB`
      - `DeleteHealthMonitorInDB.execute()`
      - `DeleteHealthMonitorInDB.revert()`
    - `DeleteHealthMonitorInDBByPool`
      - `DeleteHealthMonitorInDBByPool.execute()`
      - `DeleteHealthMonitorInDBByPool.revert()`
    - `DeleteL7PolicyInDB`
      - `DeleteL7PolicyInDB.execute()`
      - `DeleteL7PolicyInDB.revert()`
    - `DeleteL7RuleInDB`
      - `DeleteL7RuleInDB.execute()`
      - `DeleteL7RuleInDB.revert()`
    - `DeleteListenerInDB`
      - `DeleteListenerInDB.execute()`
      - `DeleteListenerInDB.revert()`
    - `DeleteMemberInDB`
      - `DeleteMemberInDB.execute()`
      - `DeleteMemberInDB.revert()`
    - `DeletePoolInDB`
      - `DeletePoolInDB.execute()`
      - `DeletePoolInDB.revert()`
    - `DisableAmphoraHealthMonitoring`
      - `DisableAmphoraHealthMonitoring.execute()`
    - `DisableLBAmphoraeHealthMonitoring`
      - `DisableLBAmphoraeHealthMonitoring.execute()`
    - `GetAmphoraDetails`
      - `GetAmphoraDetails.execute()`
    - `GetAmphoraFirewallRules`
      - `GetAmphoraFirewallRules.execute()`
    - `GetAmphoraeFromLoadbalancer`
      - `GetAmphoraeFromLoadbalancer.execute()`
    - `GetListenersFromLoadbalancer`
      - `GetListenersFromLoadbalancer.execute()`
    - `GetLoadBalancer`
      - `GetLoadBalancer.execute()`
    - `GetVipFromLoadbalancer`
      - `GetVipFromLoadbalancer.execute()`
    - `MarkAmphoraAllocatedInDB`
      - `MarkAmphoraAllocatedInDB.execute()`
      - `MarkAmphoraAllocatedInDB.revert()`
    - `MarkAmphoraBackupInDB`
      - `MarkAmphoraBackupInDB.execute()`
      - `MarkAmphoraBackupInDB.revert()`
    - `MarkAmphoraBootingInDB`
      - `MarkAmphoraBootingInDB.execute()`
      - `MarkAmphoraBootingInDB.revert()`
    - `MarkAmphoraDeletedInDB`
      - `MarkAmphoraDeletedInDB.execute()`
      - `MarkAmphoraDeletedInDB.revert()`
    - `MarkAmphoraHealthBusy`
      - `MarkAmphoraHealthBusy.execute()`
    - `MarkAmphoraMasterInDB`
      - `MarkAmphoraMasterInDB.execute()`
      - `MarkAmphoraMasterInDB.revert()`
    - `MarkAmphoraPendingDeleteInDB`
      - `MarkAmphoraPendingDeleteInDB.execute()`
      - `MarkAmphoraPendingDeleteInDB.revert()`
    - `MarkAmphoraPendingUpdateInDB`
      - `MarkAmphoraPendingUpdateInDB.execute()`
      - `MarkAmphoraPendingUpdateInDB.revert()`
    - `MarkAmphoraReadyInDB`
      - `MarkAmphoraReadyInDB.execute()`
      - `MarkAmphoraReadyInDB.revert()`
    - `MarkAmphoraStandAloneInDB`
      - `MarkAmphoraStandAloneInDB.execute()`
      - `MarkAmphoraStandAloneInDB.revert()`
    - `MarkHealthMonitorActiveInDB`
      - `MarkHealthMonitorActiveInDB.execute()`
      - `MarkHealthMonitorActiveInDB.revert()`
    - `MarkHealthMonitorPendingCreateInDB`
      - `MarkHealthMonitorPendingCreateInDB.execute()`
      - `MarkHealthMonitorPendingCreateInDB.revert()`
    - `MarkHealthMonitorPendingDeleteInDB`
      - `MarkHealthMonitorPendingDeleteInDB.execute()`
      - `MarkHealthMonitorPendingDeleteInDB.revert()`
    - `MarkHealthMonitorPendingUpdateInDB`
      - `MarkHealthMonitorPendingUpdateInDB.execute()`
      - `MarkHealthMonitorPendingUpdateInDB.revert()`
    - `MarkHealthMonitorsOnlineInDB`
      - `MarkHealthMonitorsOnlineInDB.execute()`
    - `MarkL7PolicyActiveInDB`
      - `MarkL7PolicyActiveInDB.execute()`
      - `MarkL7PolicyActiveInDB.revert()`
    - `MarkL7PolicyPendingCreateInDB`
      - `MarkL7PolicyPendingCreateInDB.execute()`
      - `MarkL7PolicyPendingCreateInDB.revert()`
    - `MarkL7PolicyPendingDeleteInDB`
      - `MarkL7PolicyPendingDeleteInDB.execute()`
      - `MarkL7PolicyPendingDeleteInDB.revert()`
    - `MarkL7PolicyPendingUpdateInDB`
      - `MarkL7PolicyPendingUpdateInDB.execute()`
      - `MarkL7PolicyPendingUpdateInDB.revert()`
    - `MarkL7RuleActiveInDB`
      - `MarkL7RuleActiveInDB.execute()`
      - `MarkL7RuleActiveInDB.revert()`
    - `MarkL7RulePendingCreateInDB`
      - `MarkL7RulePendingCreateInDB.execute()`
      - `MarkL7RulePendingCreateInDB.revert()`
    - `MarkL7RulePendingDeleteInDB`
      - `MarkL7RulePendingDeleteInDB.execute()`
      - `MarkL7RulePendingDeleteInDB.revert()`
    - `MarkL7RulePendingUpdateInDB`
      - `MarkL7RulePendingUpdateInDB.execute()`
      - `MarkL7RulePendingUpdateInDB.revert()`
    - `MarkLBActiveInDB`
      - `MarkLBActiveInDB.execute()`
      - `MarkLBActiveInDB.revert()`
    - `MarkLBActiveInDBByListener`
      - `MarkLBActiveInDBByListener.execute()`
    - `MarkLBAmphoraeDeletedInDB`
      - `MarkLBAmphoraeDeletedInDB.execute()`
    - `MarkLBAmphoraeHealthBusy`
      - `MarkLBAmphoraeHealthBusy.execute()`
    - `MarkLBAndListenersActiveInDB`
      - `MarkLBAndListenersActiveInDB.execute()`
      - `MarkLBAndListenersActiveInDB.revert()`
    - `MarkLBDeletedInDB`
      - `MarkLBDeletedInDB.execute()`
    - `MarkLBPendingDeleteInDB`
      - `MarkLBPendingDeleteInDB.execute()`
    - `MarkListenerDeletedInDB`
      - `MarkListenerDeletedInDB.execute()`
      - `MarkListenerDeletedInDB.revert()`
    - `MarkListenerPendingDeleteInDB`
      - `MarkListenerPendingDeleteInDB.execute()`
      - `MarkListenerPendingDeleteInDB.revert()`
    - `MarkMemberActiveInDB`
      - `MarkMemberActiveInDB.execute()`
      - `MarkMemberActiveInDB.revert()`
    - `MarkMemberPendingCreateInDB`
      - `MarkMemberPendingCreateInDB.execute()`
      - `MarkMemberPendingCreateInDB.revert()`
    - `MarkMemberPendingDeleteInDB`
      - `MarkMemberPendingDeleteInDB.execute()`
      - `MarkMemberPendingDeleteInDB.revert()`
    - `MarkMemberPendingUpdateInDB`
      - `MarkMemberPendingUpdateInDB.execute()`
      - `MarkMemberPendingUpdateInDB.revert()`
    - `MarkPoolActiveInDB`
      - `MarkPoolActiveInDB.execute()`
      - `MarkPoolActiveInDB.revert()`
    - `MarkPoolPendingCreateInDB`
      - `MarkPoolPendingCreateInDB.execute()`
      - `MarkPoolPendingCreateInDB.revert()`
    - `MarkPoolPendingDeleteInDB`
      - `MarkPoolPendingDeleteInDB.execute()`
      - `MarkPoolPendingDeleteInDB.revert()`
    - `MarkPoolPendingUpdateInDB`
      - `MarkPoolPendingUpdateInDB.execute()`
      - `MarkPoolPendingUpdateInDB.revert()`
    - `ReloadAmphora`
      - `ReloadAmphora.execute()`
    - `ReloadLoadBalancer`
      - `ReloadLoadBalancer.execute()`
    - `UpdateAdditionalVIPsAfterAllocation`
      - `UpdateAdditionalVIPsAfterAllocation.execute()`
    - `UpdateAmpFailoverDetails`
      - `UpdateAmpFailoverDetails.execute()`
    - `UpdateAmphoraCertBusyToFalse`
      - `UpdateAmphoraCertBusyToFalse.execute()`
    - `UpdateAmphoraComputeId`
      - `UpdateAmphoraComputeId.execute()`
    - `UpdateAmphoraDBCertExpiration`
      - `UpdateAmphoraDBCertExpiration.execute()`
    - `UpdateAmphoraInfo`
      - `UpdateAmphoraInfo.execute()`
    - `UpdateAmphoraVIPData`
      - `UpdateAmphoraVIPData.execute()`
    - `UpdateAmphoraeVIPData`
      - `UpdateAmphoraeVIPData.execute()`
    - `UpdateHealthMonInDB`
      - `UpdateHealthMonInDB.execute()`
      - `UpdateHealthMonInDB.revert()`
    - `UpdateL7PolicyInDB`
      - `UpdateL7PolicyInDB.execute()`
      - `UpdateL7PolicyInDB.revert()`
    - `UpdateL7RuleInDB`
      - `UpdateL7RuleInDB.execute()`
      - `UpdateL7RuleInDB.revert()`
    - `UpdateLBServerGroupInDB`
      - `UpdateLBServerGroupInDB.execute()`
      - `UpdateLBServerGroupInDB.revert()`
    - `UpdateListenerInDB`
      - `UpdateListenerInDB.execute()`
      - `UpdateListenerInDB.revert()`
    - `UpdateLoadbalancerInDB`
      - `UpdateLoadbalancerInDB.execute()`
    - `UpdateMemberInDB`
      - `UpdateMemberInDB.execute()`
      - `UpdateMemberInDB.revert()`
    - `UpdatePoolInDB`
      - `UpdatePoolInDB.execute()`
      - `UpdatePoolInDB.revert()`
    - `UpdatePoolMembersOperatingStatusInDB`
      - `UpdatePoolMembersOperatingStatusInDB.execute()`
    - `UpdateVIPAfterAllocation`
      - `UpdateVIPAfterAllocation.execute()`
  - octavia.controller.worker.v2.tasks.lifecycle_tasks module
    - `AmphoraIDToErrorOnRevertTask`
      - `AmphoraIDToErrorOnRevertTask.execute()`
      - `AmphoraIDToErrorOnRevertTask.revert()`
    - `AmphoraToErrorOnRevertTask`
      - `AmphoraToErrorOnRevertTask.execute()`
      - `AmphoraToErrorOnRevertTask.revert()`
    - `BaseLifecycleTask`
    - `HealthMonitorToErrorOnRevertTask`
      - `HealthMonitorToErrorOnRevertTask.execute()`
      - `HealthMonitorToErrorOnRevertTask.revert()`
    - `L7PolicyToErrorOnRevertTask`
      - `L7PolicyToErrorOnRevertTask.execute()`
      - `L7PolicyToErrorOnRevertTask.revert()`
    - `L7RuleToErrorOnRevertTask`
      - `L7RuleToErrorOnRevertTask.execute()`
      - `L7RuleToErrorOnRevertTask.revert()`
    - `ListenerToErrorOnRevertTask`
      - `ListenerToErrorOnRevertTask.execute()`
      - `ListenerToErrorOnRevertTask.revert()`
    - `ListenersToErrorOnRevertTask`
      - `ListenersToErrorOnRevertTask.execute()`
      - `ListenersToErrorOnRevertTask.revert()`
    - `LoadBalancerIDToErrorOnRevertTask`
      - `LoadBalancerIDToErrorOnRevertTask.execute()`
      - `LoadBalancerIDToErrorOnRevertTask.revert()`
    - `LoadBalancerToErrorOnRevertTask`
      - `LoadBalancerToErrorOnRevertTask.execute()`
      - `LoadBalancerToErrorOnRevertTask.revert()`
    - `MemberToErrorOnRevertTask`
      - `MemberToErrorOnRevertTask.execute()`
      - `MemberToErrorOnRevertTask.revert()`
    - `MembersToErrorOnRevertTask`
      - `MembersToErrorOnRevertTask.execute()`
      - `MembersToErrorOnRevertTask.revert()`
    - `PoolToErrorOnRevertTask`
      - `PoolToErrorOnRevertTask.execute()`
      - `PoolToErrorOnRevertTask.revert()`
  - octavia.controller.worker.v2.tasks.network_tasks module
    - `AdminDownPort`
      - `AdminDownPort.execute()`
      - `AdminDownPort.revert()`
    - `AllocateVIP`
      - `AllocateVIP.execute()`
      - `AllocateVIP.revert()`
    - `AllocateVIPforFailover`
      - `AllocateVIPforFailover.revert()`
    - `ApplyQos`
      - `ApplyQos.execute()`
      - `ApplyQos.revert()`
    - `ApplyQosAmphora`
      - `ApplyQosAmphora.execute()`
      - `ApplyQosAmphora.revert()`
    - `BaseNetworkTask`
      - `BaseNetworkTask.network_driver`
    - `BuildAMPData`
      - `BuildAMPData.execute()`
    - `CalculateAmphoraDelta`
      - `CalculateAmphoraDelta.default_provides`
      - `CalculateAmphoraDelta.execute()`
    - `CalculateDelta`
      - `CalculateDelta.default_provides`
      - `CalculateDelta.execute()`
    - `CreateSRIOVBasePort`
      - `CreateSRIOVBasePort.execute()`
      - `CreateSRIOVBasePort.revert()`
    - `CreateVIPBasePort`
      - `CreateVIPBasePort.execute()`
      - `CreateVIPBasePort.revert()`
    - `DeallocateVIP`
      - `DeallocateVIP.execute()`
    - `DeletePort`
      - `DeletePort.execute()`
    - `GetAmphoraNetworkConfigs`
      - `GetAmphoraNetworkConfigs.execute()`
    - `GetAmphoraNetworkConfigsByID`
      - `GetAmphoraNetworkConfigsByID.execute()`
    - `GetAmphoraeNetworkConfigs`
      - `GetAmphoraeNetworkConfigs.execute()`
    - `GetMemberPorts`
      - `GetMemberPorts.execute()`
    - `GetPlumbedNetworks`
      - `GetPlumbedNetworks.default_provides`
      - `GetPlumbedNetworks.execute()`
    - `GetSubnetFromVIP`
      - `GetSubnetFromVIP.execute()`
    - `GetVIPSecurityGroupID`
      - `GetVIPSecurityGroupID.execute()`
    - `HandleNetworkDelta`
      - `HandleNetworkDelta.execute()`
      - `HandleNetworkDelta.revert()`
    - `HandleNetworkDeltas`
      - `HandleNetworkDeltas.execute()`
      - `HandleNetworkDeltas.revert()`
    - `PlugNetworks`
      - `PlugNetworks.execute()`
      - `PlugNetworks.revert()`
    - `PlugPorts`
      - `PlugPorts.execute()`
    - `PlugVIPAmphora`
      - `PlugVIPAmphora.execute()`
      - `PlugVIPAmphora.revert()`
    - `RetrievePortIDsOnAmphoraExceptLBNetwork`
      - `RetrievePortIDsOnAmphoraExceptLBNetwork.execute()`
    - `UnPlugNetworks`
      - `UnPlugNetworks.execute()`
    - `UnplugVIP`
      - `UnplugVIP.execute()`
    - `UpdateVIP`
      - `UpdateVIP.execute()`
    - `UpdateVIPForDelete`
      - `UpdateVIPForDelete.execute()`
    - `UpdateVIPSecurityGroup`
      - `UpdateVIPSecurityGroup.execute()`
  - octavia.controller.worker.v2.tasks.notification_tasks module
    - `BaseNotificationTask`
      - `BaseNotificationTask.event_type`
      - `BaseNotificationTask.execute()`
    - `SendCreateNotification`
      - `SendCreateNotification.event_type`
    - `SendDeleteNotification`
      - `SendDeleteNotification.event_type`
    - `SendUpdateNotification`
      - `SendUpdateNotification.event_type`
  - octavia.controller.worker.v2.tasks.retry_tasks module
    - `SleepingRetryTimesController`
      - `SleepingRetryTimesController.on_failure()`
      - `SleepingRetryTimesController.revert()`
  - octavia.controller.worker.v2.tasks.shim_tasks module
    - `AmphoraToAmphoraeWithVRRPIP`
      - `AmphoraToAmphoraeWithVRRPIP.execute()`
  - Module contents

## Submodules

## octavia.controller.worker.v2.controller_worker module

class ControllerWorker

  Bases: `object`

  amphora_cert_rotation(amphora_id)

    Perform cert rotation for an amphora.

    Parameters:

      amphora_id – ID for amphora to rotate

    Returns:

      None

    Raises:

      AmphoraNotFound – The referenced amphora was not found

  batch_update_members(old_members, new_members, updated_members)
  create_health_monitor(health_monitor)

    Creates a health monitor.

    Parameters:

      health_monitor – Provider health monitor dict

    Returns:

      None

    Raises:

      NoResultFound – Unable to find the object

  create_l7policy(l7policy)

    Creates an L7 Policy.

    Parameters:

      l7policy – Provider dict of the l7policy to create

    Returns:

      None

    Raises:

      NoResultFound – Unable to find the object

  create_l7rule(l7rule)

    Creates an L7 Rule.

    Parameters:

      l7rule – Provider dict l7rule

    Returns:

      None

    Raises:

      NoResultFound – Unable to find the object

  create_listener(listener)

    Creates a listener.

    Parameters:

      listener – A listener provider dictionary.

    Returns:

      None

    Raises:

      NoResultFound – Unable to find the object

  create_load_balancer(loadbalancer, flavor=None, availability_zone=None)

    Creates a load balancer by allocating Amphorae.

    First tries to allocate an existing Amphora in READY state. If none are available it will attempt to build one specifically for this load balancer.

    Parameters:

      loadbalancer – The dict of load balancer to create

    Returns:

      None

    Raises:

      NoResultFound – Unable to find the object

  create_member(member)

    Creates a pool member.

    Parameters:

      member – A member provider dictionary to create

    Returns:

      None

    Raises:

      NoSuitablePool – Unable to find the node pool

  create_pool(pool)

    Creates a node pool.

    Parameters:

      pool – Provider pool dict to create

    Returns:

      None

    Raises:

      NoResultFound – Unable to find the object

  delete_amphora(amphora_id)

    Deletes an existing Amphora.

    Parameters:

      amphora_id – ID of the amphora to delete

    Returns:

      None

    Raises:

      AmphoraNotFound – The referenced Amphora was not found

  delete_health_monitor(health_monitor)

    Deletes a health monitor.

    Parameters:

      health_monitor – Provider health monitor dict

    Returns:

      None

    Raises:

      HMNotFound – The referenced health monitor was not found

  delete_l7policy(l7policy)

    Deletes an L7 policy.

    Parameters:

      l7policy – Provider dict of the l7policy to delete

    Returns:

      None

    Raises:

      L7PolicyNotFound – The referenced l7policy was not found

  delete_l7rule(l7rule)

    Deletes an L7 rule.

    Parameters:

      l7rule – Provider dict of the l7rule to delete

    Returns:

      None

    Raises:

      L7RuleNotFound – The referenced l7rule was not found

  delete_listener(listener)

    Deletes a listener.

    Parameters:

      listener – A listener provider dictionary to delete

    Returns:

      None

    Raises:

      ListenerNotFound – The referenced listener was not found

  delete_load_balancer(load_balancer, cascade=False)

    Deletes a load balancer by de-allocating Amphorae.

    Parameters:

      load_balancer – Dict of the load balancer to delete

    Returns:

      None

    Raises:

      LBNotFound – The referenced load balancer was not found

  delete_member(member)

    Deletes a pool member.

    Parameters:

      member – A member provider dictionary to delete

    Returns:

      None

    Raises:

      MemberNotFound – The referenced member was not found

  delete_pool(pool)

    Deletes a node pool.

    Parameters:

      pool – Provider pool dict to delete

    Returns:

      None

    Raises:

      PoolNotFound – The referenced pool was not found

  failover_amphora(amphora_id, reraise=False)

    Perform failover operations for an amphora.

    Note: This expects the load balancer to already be in provisioning_status=PENDING_UPDATE state.

    Parameters:

      - amphora_id – ID for amphora to failover

      - reraise – If enabled reraise any caught exception

    Returns:

      None

    Raises:

      octavia.common.exceptions.NotFound – The referenced amphora was not found

  failover_loadbalancer(load_balancer_id)

    Perform failover operations for a load balancer.

    Note: This expects the load balancer to already be in provisioning_status=PENDING_UPDATE state.

    Parameters:

      load_balancer_id – ID for load balancer to failover

    Returns:

      None

    Raises:

      octavia.common.exceptions.NotFound – The load balancer was not found.

  run_flow(func, *args, **kwargs)
  property services_controller
  update_amphora_agent_config(amphora_id)

    Update the amphora agent configuration.

    Note: This will update the amphora agent configuration file and

      update the running configuration for mutatable configuration items.

    Parameters:

      amphora_id – ID of the amphora to update.

    Returns:

      None

  update_health_monitor(original_health_monitor, health_monitor_updates)

    Updates a health monitor.

    Parameters:

      - original_health_monitor – Provider health monitor dict

      - health_monitor_updates – Dict containing updated health monitor

    Returns:

      None

    Raises:

      HMNotFound – The referenced health monitor was not found

  update_l7policy(original_l7policy, l7policy_updates)

    Updates an L7 policy.

    Parameters:

      - l7policy – Provider dict of the l7policy to update

      - l7policy_updates – Dict containing updated l7policy attributes

    Returns:

      None

    Raises:

      L7PolicyNotFound – The referenced l7policy was not found

  update_l7rule(original_l7rule, l7rule_updates)

    Updates an L7 rule.

    Parameters:

      - l7rule – Origin dict of the l7rule to update

      - l7rule_updates – Dict containing updated l7rule attributes

    Returns:

      None

    Raises:

      L7RuleNotFound – The referenced l7rule was not found

  update_listener(listener, listener_updates)

    Updates a listener.

    Parameters:

      - listener – A listener provider dictionary to update

      - listener_updates – Dict containing updated listener attributes

    Returns:

      None

    Raises:

      ListenerNotFound – The referenced listener was not found

  update_load_balancer(original_load_balancer, load_balancer_updates)

    Updates a load balancer.

    Parameters:

      - original_load_balancer – Dict of the load balancer to update

      - load_balancer_updates – Dict containing updated load balancer

    Returns:

      None

    Raises:

      LBNotFound – The referenced load balancer was not found

  update_member(member, member_updates)

    Updates a pool member.

    Parameters:

      - member_id – A member provider dictionary to update

      - member_updates – Dict containing updated member attributes

    Returns:

      None

    Raises:

      MemberNotFound – The referenced member was not found

  update_pool(origin_pool, pool_updates)

    Updates a node pool.

    Parameters:

      - origin_pool – Provider pool dict to update

      - pool_updates – Dict containing updated pool attributes

    Returns:

      None

    Raises:

      PoolNotFound – The referenced pool was not found

retryMaskFilter(record)

## octavia.controller.worker.v2.taskflow_jobboard_driver module

class JobboardTaskFlowDriver

  Bases: `object`

  abstract job_board(persistence)

    Setting up jobboard backend based on configuration setting.

    Parameters:

      persistence – taskflow persistence backend instance

    Returns:

      taskflow jobboard backend instance

class MysqlPersistenceDriver

  Bases: `object`

  get_persistence()
  initialize()

class RedisTaskFlowDriver(persistence_driver)

  Bases: `JobboardTaskFlowDriver`

  job_board(persistence)

    Setting up jobboard backend based on configuration setting.

    Parameters:

      persistence – taskflow persistence backend instance

    Returns:

      taskflow jobboard backend instance

class ZookeeperTaskFlowDriver(persistence_driver)

  Bases: `JobboardTaskFlowDriver`

  job_board(persistence)

    Setting up jobboard backend based on configuration setting.

    Parameters:

      persistence – taskflow persistence backend instance

    Returns:

      taskflow jobboard backend instance

## Module contents

this page last updated: 2026-04-02 20:14:22

Except where otherwise noted, this document is licensed under Creative Commons Attribution 3.0 License. See all OpenStack Legal Documents.

found an error? report a bug